c
c filter to reformat SCSN summary data into CNSS unified format
c
	implicit none
        character*2     auxrmk
        character*8     date
	real		depth
	real		errh
	real		errz
	integer		eventid
        integer         id(3)
	integer		iday
	integer		ihour
	integer		imin
	integer		imonth
	integer		iunit
	integer		iyear
	real		latdeg
	real		latd
	real		latmin
	character*2	loctyp
	real		londeg
	real		lond
	real		lonmin
	integer		nps_sol
	integer		ounit
	real		pmag
	character*1	qual
	real		rms
	real		sec
	character*3	src
	integer		iline
	integer		ios
c
	parameter (iunit = 5, ounit = 6)
c
        call idate(id)
        write (date, '(i4, 2i2.2)'), id(3), id(2), id(1)
	loctyp = 'H '
c	Network Code
	src = 'CI'
        auxrmk = 'L '
c
	write (ounit, '(a)') '$fmt cnss-catalog-ver-1.0'
c
	iline =0
10	iline = iline + 1
        read (iunit, 100, iostat = ios, end = 1000) 
	1         iyear, imonth, iday, ihour, imin, sec, latdeg, 
	2         latmin, londeg, lonmin, qual, pmag, depth, nps_sol, 
	3         rms, eventid
100       format (i4, 2(1x,i2), 1x, 2(1x, i2), 1x, f5.2, 1x, f3.0, 
	1        1x, f5.2, f4.0, 1x, f5.2, 1x, a1, 1x, f3.1, t55, f5.2,i3,
	2        t67, f4.2, 1x, i7)
	if (ios .ne. 0) then
	  print *, 'error on line ', iline
	  goto 10
	endif
	lond = sign(abs(londeg) + abs(lonmin)/60., londeg)
	latd = sign(abs(latdeg) + abs(latmin)/60., latdeg)
	if (lond .eq. 0. .and. latd .eq. 0.) then
	  goto 10
	endif
c
c map SCSN qualities to errh, errz
c
	if (qual .eq. 'A') then
	  errh = 1.0
	  errz = 2.0
	elseif (qual .eq. 'B') then
	  errh = 2.0
	  errz = 5.0
	elseif (qual .eq. 'C') then
	  errh = 5.0
	  errz = 99.0
	else
	  errh = 99.0
	  errz = 99.0
	endif
c
c write out $beg line
c
        write (ounit, '(a4)') '$beg'
c
c write out $loc line
c
        write (ounit, 200) iyear, imonth, iday, ihour, imin, sec,
	1 latd, lond, depth, loctyp, src, nps_sol, rms,
	2 errh, errz, auxrmk, date
200     format ('$loc ', i4, 4i2.2, f7.4,
	1 f9.5, f10.5, f8.4, a2, a3, i4, 13x, f7.4,
	2 t88, 2f7.4, a2, a8)
c
c write out $add line
c
	write (ounit, 300) eventid
300     format ('$add$loc', t86, i12)
c
c output $mag line. 
c
	if (pmag .gt. 0.) then
	  write (ounit, 400) pmag, src, date 
400	  format ('$mag', 'P', f5.2, 'c ', a3, 13x, a8)
	end if
c
c write out $end line
c
	write (ounit, '(a)') '$end'
	goto 10
1000	continue
	close (2)
	close (ounit)
	end
