      program  uw2cnss
c routine for reformatting U.W pickfile summary into the CNSS catalog format
c USAGE: uw2cnss <loc.??
c    USAGE:  uwpk2cnss pickfile....
c     or:    cat pickfile... | uwpk2cnss
c     or:    uwpk2cnss loc_file
c
      integer lu1,lu2,lu4
      integer inverse
      character*85 f2
      character*220 card
      character*1 ip,is,t1,t2,t3,t4,t5,t6,t7,t8
      character*2 t9
      integer ll
      integer itime,time
      integer nowtime(9)
      external getarg,iargc
      data ip/'P'/,is/'S'/
	lu1 = 5
	lu2 = 6
	lu4 = 8
c
	inverse = 0
	tol = .0001
        nopol="  "
	itime=time()
	call ltime(itime,nowtime)
c
      n=iargc()
	if( n .eq. 0 ) then
		lu4 = lu1
		n = 1
	endif
	
      do 111 index=1,n
      if(lu4 .ne. 5 ) then
      	call getarg(index,f2)
	if(f2 .eq.'-i') then
		inverse=1
		goto 111
	endif
c-----------------------------------------
c open the file to be reformatted
      	open (unit=lu4,file=f2,status='old',err=900) 
      	rewind lu4 
      endif

c  List starting description line
	write(lu2,511)
511	format("$fmt cnss-catalog-ver-1.0")


c   Loop to here line by line
20      read(lu4,500,end=111)card
        ll=lnblnk(card)
500     format(a80)
c IF IT IS A "SUMARY" CARD
c  rewrite summary card data to  card2
        if (card(1:1).eq."A") then
c summary card, ignore non-locates and teleseisms
		if(ll .lt. 70)goto 20
		if(card(2:2) .eq. "T")goto 20
		read(card,510)t1,t2,iyr,imo,iday,ihr,
     +          imin,sec,latd,t3,ilatm,longd,t4,ilongm,
     +          depth,t5,rmag,nsta,t6,nphas,igap,idelt,rms,
     +		err,t7,t8,t9
510   		format(a1,a1,5i2,f6.2,i3,a1,i4,i4,a1,i4,f6.2,
     +		a1,f4.1,i3,a1,i3,i4,i3,f5.2,f5.1,2a1,1x,a2)
c
		ihour=ihr
		iminute=imin
		second=sec
		isec=(float(sec))*100.
		idepth=(float(depth))*100.
		irms=(float(rms))*100.
		ierr=(float(err))*100.
		ifmag=(float(rmag))*10.
		if(ifmag .eq. 0)goto 20
                rdelt=float(idelt)
                rlatm=(float(ilatm))/100.
		rlatm=float(latd) + rlatm/60.
                rlongm=(float(ilongm))/100.
		rlongm=-float(longd) - rlongm/60.
		jlatm = ilatm/100
		jlonm = ilongm/100
		jlats = (ilatm - jlatm*100)* 0.6
		jlons = (ilongm - jlonm *100) *0.6
		if(rms .gt. 9.8)rms=9.9
		if(second .lt.0.0)then
			iminute = iminute+ifix(-1 + second/60.)
			second = second - 60. * ifix(-1 + second/60.)
			if(iminute .lt. 0) then
				ihour = ihour-1
				iminute=iminute+60
			endif
		endif
		if(second .gt. 60.0) then
			iminute = iminute+ifix(second/60.)
			second = second - 60.0 * ifix(second/60.)
			if(iminute .gt. 59)then
				ihour = ihour+1
				iminute=iminute-60
			endif
		endif
		if(t2 .eq. " ")t2="L"
		if(t2 .eq. "P" .or. t2 .eq. "X" )t2="Q"


	write(lu2,512)iyr,imo,iday,ihour,iminute,second,
     +	rlatm,rlongm,depth,
     +	nphas,igap,rdelt,rms,err,t2,
     +  nowtime(6),nowtime(5)+1,nowtime(4)

c    NOTE:  Network Code is "UW" in format statements
512     format("$beg",/,"$loc 19",5i2.2,f7.4,
     +	f9.5,f10.5,f8.4,'H UW ',
     +  i4,i3,f10.4,f7.4,14x,f7.4,a1,
     +  " 19",3i2.2)

        write(lu2,513)  rmag
513	format("$mag ",f5.2,"c UW ",/,"$end")
        goto 20
        endif
c
        goto 20
c******************************************************************
111      continue
	stop
900     continue
	write(0,*)"Error opening input file"
        end
